/*路况 */
class Traffic {
    constructor(config) {
            this.mapObj = config.map;
            this.trafficLayer = null;
            this.opt = config.opt;
            this.isShow = false;
            this.load();
        }
        /**
         * 初始化
         */
    load() {
            this.trafficLayer = new AMap.TileLayer.Traffic();
            if (this.opt) {
                this.trafficLayer.G.autoRefresh = this.opt.autoRefresh;
                this.trafficLayer.G.interval = this.opt.interval;
            }

            this.trafficLayer.setMap(this.mapObj);
            this.hide()
        }
        /**
         * 显示
         */
    show() {
            this.trafficLayer.show();
        }
        /**
         * 隐藏
         */
    hide() {
            this.trafficLayer.hide();
        }
        /**
         * 点击显示和隐藏
         */
    clickShow() {
        if (!this.isShow) {
            this.show();
            this.isShow = true;
        } else {
            this.hide();
            this.isShow = false;
        }
    }

}
/**卫星 */
class Satellite {
    constructor(config) {
            this.mapObj = config.map;
            this.opt = config.opt;
            this.satellite = null;
            this.isShow = false;
            this.load();
        }
        /**
         * 初始化
         */
    load() {
            //debugger;
            let satellite = new AMap.TileLayer.Satellite(this.opt);
            satellite.setMap(this.mapObj);
            satellite.hide();
            this.satellite = satellite;
        }
        /**
         *显示
         */
    show() {
            this.satellite.show();
        }
        /**
         * 隐藏
         */
    hide() {
            this.satellite.hide();
        }
        /**
         * 点击显示或隐藏
         */
    clickShow() {
        if (!this.isShow) {
            this.show();
            this.isShow = true;
        } else {
            this.hide();
            this.isShow = false;
        }
    }
}
/**路网 */
class RoadNet {
    constructor(config) {
            this.mapObj = config.map;
            this.opt = config.opt;
            this.RoadNet = null;
            this.isShow = false;
            this.load();
        }
        /**
         * 初始化
         */
    load() {
            //debugger;
            let roadNet = new AMap.TileLayer.RoadNet(this.opt);
            roadNet.setMap(this.mapObj);
            roadNet.hide();
            this.RoadNet = roadNet;
        }
        /**
         * 点击显示
         */
    show() {
            this.RoadNet.show();
        }
        /**
         * 隐藏
         */
    hide() {
            this.RoadNet.hide();
        }
        /**
         * 点击显示或隐藏
         */
    clickShow() {
        if (!this.isShow) {
            this.show();
            this.isShow = true;
        } else {
            this.hide();
            this.isShow = false;
        }
    }
}
export { Traffic, Satellite, RoadNet }