﻿/**
 *  使用鼠标工具，在地图上画标记点
 */
    
export default class AmapMouseTool {
    constructor(config) {
        this.mapObj = config.map;
        this.mouseTool = null,
        this. drawListener = null;
        this.load();
    
    };
    load() {
            if (!this.mouseTool) {
                this.mouseTool = new AMap.MouseTool(this.mapObj);
            }
        }
        /**
         * 私有方法 移除监听事件
         */
    _removeListener() {
            if (this.drawListener) {
                AMap.event.removeListener(this.drawListener); //移除事件，以绑定时返回的对象作为参数
            }
        }
        /**
         * 
         * @param {参数对象} objData 
         */
    mouseToolOpen(objData) {
            switch (objData.name) {
                case 'marker':
                   this. mouseTool.marker();
                    break;
                case 'polyline':
                this. mouseTool.polyline();
                    break;
                case 'polygon':
                this.  mouseTool.polygon();
                    break;
                case 'rectangle':
                this.  mouseTool.rectangle();
                    break;
                case 'circle':
                this.mouseTool.circle();
                    break;
                case 'rule':
                this.  mouseTool.rule();
                    break;
                case 'measureArea':
                this. mouseTool.measureArea();
                    break;
                case 'rectZoomIn':
                this. mouseTool.rectZoomIn();
                    break;
                case 'rectZoomOut':
                this.  mouseTool.rectZoomOut();
                    break;
            }
            this._removeListener();
            let $this=this;
            this.drawListener = AMap.event.addListener( this.mouseTool, "draw", function(e) {
                let drawData = {
                    radius: 0,
                    points: null
                }
                switch (e.obj.CLASS_NAME) {
                    case "AMap.Circle":
                        drawData.radius = e.obj.getRadius();
                        drawData.points = e.obj.getCenter();
                        break;
                    case "AMap.Polygon":
                        drawData.points = e.obj.getPath();
                        break;
                }
                $this.mouseTool.close();
              
                objData.events.draw(drawData);
            });
        }
        /**
         * 关闭当前鼠标操作。参数arg设为true时，鼠标操作关闭的同时清除地图上绘制的所有覆盖物对象；设为false时，保留所绘制的覆盖物对象。默认为false
         */
    mouseToolColse() {
        if (! this.mouseTool) throw new Error("必须先注册鼠标工具");
        this. mouseTool.close(true);
    }



};