﻿import { toLngLat } from '../utils/convert-helper.js';
import eventHelper from '../utils/event-helper.js'
export default class simpleInfoWindow {
    constructor(config) {
        this.mapObj = config.map;
        this.infoWindow = null;
        this.init();
       // this.key = null;
    }

    init() {
        let $ref = this;
        AMapUI.loadUI(['overlay/SimpleInfoWindow'], function (SimpleInfoWindow) {
            console.log('SimpleInfoWindow');
            $ref.infoWindow = new SimpleInfoWindow({
                offset: new AMap.Pixel(-3.5, -11),
                isCustom: true,
                autoMove: true,
                showShadow:true,
            });
            //eventHelper.addListener($ref.infoWindow, 'close', function(e) {
            //    $ref.infoWindow.close();
            //    this.key = null;
            //});
        });
    }

    /**
     * 打开
     * @param {*} data 
     */
    open(data) {
        this.key = data.key;
        this.infoWindow.setInfoTitle(data.title);
        this.infoWindow.setInfoBody(data.body);
        if (data.position && data.position instanceof Array) {
            data.position = toLngLat(data.position);
        } else {
            throw new Error("位置字段必须传入");
        }
        this.infoWindow.open(this.mapObj, data.position);
    }

    /**
     * 关闭
     */
    close() {
        if (this.infoWindow == null) return;
        let isopen = this.infoWindow.getIsOpen();
        if (isopen) {
            this.infoWindow.close();
        }
    }

    /**
     * name:'注册名'
     * cb回掉函数
     * 注册事件
     */
    events(name, cb) {
        let $this = this.infoWindow;
        if ($this)
        {
            eventHelper.addListener($this, name, cb);
        }
    }
}