﻿import { lngLatTo, toLngLat, toPixel } from '../utils/convert-helper.js';
import eventHelper from '../utils/event-helper.js'
export default class simpleMarker {
    constructor(config) {
            this.mapObj = config.map;
            this.simpleMarker = null;
            this.init();
            this.simpleMarks = new Map(); //缓存标记信息
        }
        /**
         * 初始化简单标注
         */
    init() {
            let $ref = this;
            AMapUI.loadUI(['overlay/SimpleMarker'], function(SimpleMarker) {
                $ref.simpleMarker = SimpleMarker;
            });
        }
        /**
         * 添加简单标注信息
         */
    addSimpleMarkers(markers) {
    
            if (typeof this.simpleMarker != 'object' && !this.simpleMarker)
                throw new Error("SimpleMarker-简单标注");

            let _realMarker = this.converMarkerProp(markers);
            let _marks = this.registerEvents(_realMarker);

            _marks.forEach(function(element) {
                this.simpleMarks.set(element.opts.key, element);
            }, this);
        }
        /**
         * 移除简单标记信息
         */
    removeSimpleMarkers(keys) {
            if (typeof this.simpleMarker != 'object' && !this.simpleMarker)
                throw new Error("SimpleMarker-简单标注");

            keys.forEach(function(el) {
                let _mark = this.simpleMarks.get(el);
                if (_mark)
                    _mark.setMap(null);
                }, this)
                //
            keys.forEach(function(ele) {
                this.simpleMarks.delete(ele);
            }, this)
        }
        /**
         * 内部转换
         * @param {对象} markers 
         */
    registerEvents(markers) {
            let marks = [];
            markers.forEach(function(mark) {
                if (!mark.iconStyle) {
                    let iconStyles = this.simpleMarker.getBuiltInIconStyles(mark.iconTheme);
                    mark.iconStyle = iconStyles[3];
                }

                let markinfo = new this.simpleMarker(mark);
                for (let k in mark.events) {
                    let v = mark.events[k];
                    if (k === 'init') {
                        v(markinfo);
                    } else {
                        eventHelper.addListener(markinfo, k, v);
                    }
                }
                marks.push(markinfo);
            }, this)
            return marks;
        }
        /**
         * 内部转换信息
         */
    converMarkerProp(markers) {
        markers.forEach(function(_marker) {
            _marker.map = this.mapObj;
            if (_marker.position && _marker.position instanceof Array) {
                _marker.position = toLngLat(_marker.position);
            }
            if (_marker.offset && _marker.offset instanceof Array) {
                _marker.offset = toPixel(_marker.offset);
            }
            if (_marker.label && _marker.label instanceof Object) {
                _marker.label.offset = toPixel(_marker.label.offset);
            }
        }, this);
        return markers;
    }
}